
-- Local Globals

	local _G = _G;
	local SN_STRIKENOWOPTIONS_ROOT_FRAME = SN_STRIKENOWOPTIONS_ROOT_FRAME;



function StrikeNowOptions_OnLoad(self)

	if ( SN_DEBUG )
	then
		DEFAULT_CHAT_FRAME:AddMessage("StrikeNowOptions_OnLoad driven");
	end;

	if (SN_ADD_TO_INTERFACE )
	then
		-- DEFAULT_CHAT_FRAME:AddMessage("Adding Category to Interface");
		StrikeNowOptions_AddCategory( self );
	else
		-- DEFAULT_CHAT_FRAME:AddMessage("Hiding StrikeNowOptions (StrikeNow! not active)");
		self:Hide();
	end;

end;


function StrikeNowOptions_AddCategory( self )

	if ( SN_DEBUG )
	then
		DEFAULT_CHAT_FRAME:AddMessage("StrikeNowOptions_AddCategory driven");
	end;

	-- Set panel name
	self.name = SN;

	-- Set defaults function
	self.default = function( self )
		StrikeNow_Reset();
	end;

	-- Set refresh function
	self.refresh = function( self )
		StrikeNowOptions_SetData();
	end;


        -- Add the panel
	InterfaceOptions_AddCategory( self );
end;


--
-- Set all Interface control widgets to match the current values 
--
function StrikeNowOptions_SetData()

	if ( SN_DEBUG )
	then
		DEFAULT_CHAT_FRAME:AddMessage("StrikeNowOptions_SetData driven");
	end;

	SN_Options_Toggle_UseGraphic:SetChecked( SN_ConfigData.useGraphic );
	StrikeNowOptions_GraphicsSubopts( SN_ConfigData.useGraphic );

	SN_Options_Toggle_Group1_AlternateGraphic:SetChecked( SN_ConfigData.altMonitorGraphic );
	SN_Options_Toggle_Group1_GraphicScale:SetValue( SN_ConfigData.graphicScale );


	SN_Options_Toggle_UseGlow:SetChecked( SN_ConfigData.useGlow );
	StrikeNowOptions_UseGlowSubopts( SN_ConfigData.useGlow );

	SN_Options_Toggle_Group2_Cleave:SetChecked( SN_ConfigData.useCleave);

	SN_Options_Toggle_Threshold_Main:SetValue( SN_ConfigData.thresholdMain );
	SN_Options_Toggle_Threshold_Alt:SetValue( SN_ConfigData.thresholdAlt );

end;


--
-- Protect the graphics suboption controls when the monitor graphic is not in use
-- 
function StrikeNowOptions_GraphicsSubopts(checked)

	if ( checked )
	then
		StrikeNowOptions_Group1_EnableMouse(true);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1"]:SetAlpha(SN_MAX_ALPHA);

	else
		StrikeNowOptions_Group1_EnableMouse(false);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1"]:SetAlpha(SN_FADE_ALPHA);

		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1_FrameUnlock"]:SetChecked(false);
		StrikeNow_FrameUnlock(false);
	end;

end;


function StrikeNowOptions_Group1_EnableMouse(bool)

	_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1_AlternateGraphic"]:EnableMouse(bool);
	_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1_FrameUnlock"]:EnableMouse(bool);
	_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group1_GraphicScale"]:EnableMouse(bool);


end;


function StrikeNowOptions_UseGlowSubopts(checked)

	if ( checked )
	then
		StrikeNowOptions_Group2_EnableMouse(true);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group2"]:SetAlpha(SN_MAX_ALPHA);

	else
		StrikeNowOptions_Group2_EnableMouse(false);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group2"]:SetAlpha(SN_FADE_ALPHA);

	end;

end;


function StrikeNowOptions_Group2_EnableMouse(bool)

	_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Group2_Cleave"]:EnableMouse(bool);

end;


function StrikeNowOptions_Toggle_Show(show)

	if (show) 
	then
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Subtext"]:SetText (SN_OPTIONS_SUBTEXT);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle"]:Show();
	else
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Subtext"]:SetText (SN_HS_NOT_KNOWN);
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle"]:Hide();
	end;

end;


function StrikeNowOptions_Show_Alt(show)

	if (show) 
	then
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Alt"]:Show();
	else
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Alt"]:Hide();
	end;

end;


function StrikeNowOptions_Main_Threshold_Active(bool)

	if (bool) 
	then
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Main_Active"]:Show();
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Alt_Active"]:Hide();

	else
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Main_Active"]:Hide();
		_G[SN_STRIKENOWOPTIONS_ROOT_FRAME.."_Toggle_Threshold_Alt_Active"]:Show();

	end;

end;


function StrikeNowOptions_ConfigChange()

	if ( SN_DEBUG )
	then
		DEFAULT_CHAT_FRAME:AddMessage("StrikeNowOptions_ConfigChange driven");
	end;

	SN_Options:Hide();
	SN_Options:Show();

end;
